/* user macros .. */
#define oxl_height oxl.buf.uh
#define oxl_width oxl.buf.uw
#define BUFFSIZE(w,h,d) ((w)*(h)*(((d)+1)>>3))
#define AUBYPS (oxl.au.bits>>(3-oxl.au.chs))
#define OXLMSG(a) fprintf(stderr,a)

#include "oxlconfig.h"

#ifndef __OXL_C
	extern
#endif
struct{
	struct{
	   int vh,vw,vd; char *vdata;
	   int h, w, d;  char *data;	  
	   int bpvl;
	   int uh,uw;
	}buf;
	struct{
		int hz,chs,bits,outmode;
	}au;
	struct{
		void(*video_ready)();
		void(*video_blit)();
		void(*video_setpalette)(int*pal,int colorcount);

		void(*audio_send)(void*buffer,int length);
		void(*audio_play)(void(*player)());
		void(*audio_check)();

		int(*timer)();
		int(*testquit)();
	}drv;
	struct {
		int zoom;
	}opt;

	int timerhz;

	int directvideo;

	int help;
	int nosnd;
	int inited;  /* -> flags */
	int use_scaler;
	int use_direct;

	int quitsigns;

	void(*destr[10])();
}oxl;

#ifndef __OXL_C
   extern
#endif
struct
{
   int dx,dy;
   void(*inloop0)(void*data,void*vdata,int i);
   void(*inloop1)(void*data,void*vdata,int i);
   void*temp;
#ifdef SUPPORT_8TO16
   short16 conv8to16[256];
#endif
}oxlscaler;

/* are these used somewhere? */
#define OXL_ZOOM_USERZ 1
#define OXL_ZOOM_USERC 2
#define OXL_SIGNED   1
#define OXL_BIGEND   4
#define OXL_RAWDATA  8
#define OXL_CLIPIT   16

/* misc funcs */

int findarg(int*argc,char**argv,char*key);
void oxl_regdestr(void(*func)());
extern int oxl_evalmode(
   int w,int h,int d,int vw,int vh,int vd,int*max);
void oxl_scaler_setpalette(int*pal,int colorcount);

/* video scaler loops */

void oxl_scaler_x8_1(void*data,void*vdata,int i);
void oxl_scaler_x8_1to2(void*data,void*vdata,int i);
void oxl_scaler_x8_1to4(void*data,void*vdata,int i);
void oxl_scaler_x8_any(void*data,void*vdata,int i);
void oxl_scaler_x16_1(void*data,void*vdata,int i);
void oxl_scaler_x16_any(void*data,void*vdata,int i);
void oxl_scaler_x16_1to2(void*data,void*vdata,int i);
void oxl_scaler_x8to16_1(void*data,void*vdata,int i);

/* audio mixer/scaler loops */

void oxl_mixer_clip32(int*s,int length);
void oxl_mixer_scale8u(void*o,void*i,int length);
void oxl_mixer_scale8s(void*o,void*i,int length);
void oxl_mixer_scale16u(void*o,void*i,int length);
void oxl_mixer_scaler16s(void*o,void*i,int length);

/* ok */

