#include "oxl.h"

#include <stdio.h>
#include <stdlib.h>

#ifdef __linux__
#include <linux/string.h>
#endif
#include <string.h>
	
/***************** 8->8 zoomers ********************/

#ifdef SUPPORT_8BPP
void oxl_scaler_x8_1(void*data,void*vdata,int i)
{
	memcpy(data,vdata,i);
}

void oxl_scaler_x8_1to2(void*data,void*vdata,int i)
{
#if (OXL_ASMLOOPS==386)

__asm__("
	jmp 0f
	.align 4

0:	lodsl

	movl %%eax,%%edx
	movb %%ah,%%al

	roll $16,%%eax
	
	movb %%dl,%%al
	movb %%dl,%%ah
	
	stosl

	roll $16,%%edx

	movb %%dh,%%al
	movb %%dh,%%ah

	roll $16,%%eax
	
	movb %%dl,%%al
	movb %%dl,%%ah
	
	stosl

	lodsl
	
	movl %%eax,%%edx
	movb %%ah,%%al

	roll $16,%%eax
	
	movb %%dl,%%al
	movb %%dl,%%ah
	
	stosl

	roll $16,%%edx

	movb %%dh,%%al
	movb %%dh,%%ah

	roll $16,%%eax
	
	movb %%dl,%%al
	movb %%dl,%%ah
	
	stosl

	decl %%ecx
	jne 0b
"::"c"(i>>4),"S"(data),"D"(vdata)
  :"ax","cx","dx","si","di");

#else

	char8*d=data,*vd=vdata;

	for(i>>=1;i;i--){
		vd[0]=vd[1]=*d++;vd+=2;
	}
	
#endif
}

void oxl_scaler_x8_1to4(void*data,void*vdata,int i)
{

#if (OXL_ASMLOOPS==386)

__asm__("
	jmp 0f
	.align 4

0:	lodsl

	movl %%eax,%%edx

	movb %%al,%%ah
	stosw
	stosw

	movb %%dh,%%al
	movb %%dh,%%ah
	stosw
	stosw

	roll $16,%%edx

	movb %%dl,%%al
	movb %%dl,%%ah
	stosw
	stosw

	movb %%dh,%%al
	movb %%dh,%%ah
	stosw
	stosw

	decl %%ecx
	jne 0b
":: "c"(i>>4), "S"(data), "D"(vdata)
  : "ax","cx","dx","si","di");

#else

	unsigned char*d=data;int32*vd=vdata;

	for(i>>=2;i;i--){
		int32 a=*d++;
		a|=(a<<8);
		a|=(a<<16);
		*vd++=a;
	}
	
#endif

}

void oxl_scaler_x8_any(void*data,void*vdata,int i)
{
#if (OXL_ASMLOOPS==386)
__asm__("

	movb $0,%%bh
	jmp 0f

	.align 4

0:	movb (%%esi),%%al
	addb %%bl,%%bh
	adcl %%edx,%%esi

	movb (%%esi),%%ah
	addb %%bl,%%bh
	adcl %%edx,%%esi

	roll $16,%%eax
	
	movb (%%esi),%%al
	addb %%bl,%%bh
	adcl %%edx,%%esi

	movb (%%esi),%%ah
	addb %%bl,%%bh
	adcl %%edx,%%esi

	roll $16,%%eax
	stosl
	
	decl %%ecx
	jne 0b

":: "c"(i>>2), "S"(data), "D"(vdata), "b"(oxlscaler.dx&0xff),
    "d"(oxlscaler.dx>>8)
  : "ax","cx","bx","si","di","dx");

#else

	char8*d=data,*vd=vdata;
	int x=0,dx=oxlscaler.dx;
	for(;i;i--){*vd++=d[x>>8];x+=oxlscaler.dx;}
#endif
}
#endif

/***************** 16->16 zoomers ******************/

#ifdef SUPPORT_16BPP
void oxl_scaler_x16_1(void*data,void*vdata,int i)
{
	memcpy(data,vdata,i<<1);
}

void oxl_scaler_x16_any(void*data,void*vdata,int i)
{
	short16*d=data,*vd=vdata;
	int x=0,dx=oxlscaler.dx;
	for(;i;i--){*vd++=d[x>>8];x+=oxlscaler.dx;}
}

void oxl_scaler_x16_1to2(void*data,void*vdata,int i)
{
	short16*d=data,*vd=vdata;
	for(i>>=1;i;i--){
		*vd++=*vd++=*d++;
	}
}
#endif

/***************** 8->16 conversion ***************/

#ifdef SUPPORT_8TO16
void oxl_scaler_x8to16_1(void*data,void*vdata,int i)
{
#ifndef __i586__
	char8 *d=data;
	short16 *vd=vdata;      	
	while (i--) 
		*vd++=oxlscaler.conv8to16[*d++];
#else
/* ATTENTION: "data" should have one additional padding byte after the
 * actual data in order to avoid segmentation faults. I have not
 * personally experienced any sig11's yet, but it is possible. Run
 * length must be the multiple of 2.
 */

/* This code runs theoretically at 3.5 clocks/pixel, but in practice it
 * takes 3.75-4.5 clocks/pixel. The best version EGCS produced ran at
 * 7.5 clocks/pixel, and GCC presumably would have achieved the rate of
 * 10 clocks/pixel or so. 
 */  	
	__asm__("
	push %%ebp
	mov %%edx, %%ebp

	lea (%%esi, %%ecx), %%esi
	negl %%ecx

	xorl %%ebx, %%ebx
	movb 1(%%esi, %%ecx), %%dl
	movb (%%esi, %%ecx), %%bl
	andl $255, %%edx

1:	movw (%%ebp, %%edx, 2), %%ax
	movb (%%ecx, %%esi), %%bl
	shll $16, %%eax
	addl $4, %%edi
	movw (%%ebp, %%ebx, 2), %%ax
	movb 3(%%ecx, %%esi), %%dl
	movl %%eax, -4(%%edi)
	addl $2, %%ecx
	jnz 1b

	pop %%ebp
	"::"S"(data), "D"(vdata), "c"(i), "d"(oxlscaler.conv8to16)
	:"ax", "bx", "cx", "dx", "si", "di");
#endif
}
#endif

/**************/ /* mixer loops */

void oxl_mixer_clip32(int*s,int length)
{
	for(;length;length--){
		int a=*s,b;
		if((b=(a+0x8000)&0xffff0000)){
			if(b<0)*s=-0x7fff;else*s=0x7fff;
		}
		s++;
	}
}

/* oxl_mixer_tabclip8u */

void oxl_mixer_scale8u(void*o,void*i,int length)
{
	int j;char8*o8=o,*i8=i
#ifdef BIG_ENDIAN
	+2;
#else
	+1;
#endif
	for(j=length;j;j--){*o8++=*i8^0x80;i8+=4;}
}

void oxl_mixer_scale8s(void*o,void*i,int length)
{
	int j;char8*o8=o,*i8=i
#ifdef BIG_ENDIAN
	+2;
#else
	+1;
#endif
	for(j=length;j;j--){*o8++=*i8;i8+=4;}
}

void oxl_mixer_scale16u(void*o,void*i,int length)
{
	int j;short16*o16=o,*i16=i
#ifdef BIG_ENDIAN
	+1;
#else
	+0;
#endif
	for(j=length;j;j--){*o16++=*i16^0x8000;i16+=2;}
}

void oxl_mixer_scale16s(void*o,void*i,int length)
{
	int j;short16*o16=o,*i16=i
#ifdef BIG_ENDIAN
	+1;
#else
	+0;
#endif
	for(j=length;j;j--){*o16++=*i16;i16+=2;}
}
