/* fix dga & xlibfullscreen */

/*** HEADERS **********************************************/

#include "oxlconfig.h"
#ifdef SUPPORT_X11

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#ifdef SUPPORT_MITSHM
	#include <sys/ipc.h>
	#include <sys/shm.h>
	#include <X11/extensions/XShm.h>
#endif

#ifdef SUPPORT_XF86VM
	#include <X11/Xmd.h>
	#include <X11/extensions/xf86vmstr.h>
#endif

#ifdef SUPPORT_XF86DGA
	#include <X11/extensions/xf86dgastr.h>
#endif

#ifdef SUPPORT_RAWX
	#include <X11/Xlibint.h>
#endif

#include "oxl.h"

/*** INTERNAL DRIVER DATA *********************************/

struct{
	Display *disp;
	Visual *vis;
	GC gc;
	int win,scr,rootw,dummyw;
	XImage *im;

	char*winname;
	Colormap cmap;
	XColor cols[256];

	#ifdef SUPPORT_MITSHM
		XShmSegmentInfo ssi;
	#endif
	#ifdef SUPPORT_XF86VM
		int xf86vm_majop;
	#endif

	struct{
		int w,h;
	}savedmode;

	struct{
		int useXShm;
		int useDGA;
		int changemode;
		int fullscreen;
#ifdef SUPPORT_REDUCEDSCAN
		int interlaced;
		int halvescans;
#endif
		int kindcolors;
	}opt;
}oxlX;

/*** SMALL API FUNX ****************************************/

void oxlX11_setpalette(int*pal,int colorcount)
{
	int*p=pal,i;XColor*c=oxlX.cols;
	for(i=colorcount;i;i--){
		c->red=(*p++<<8);
		c->green=(*p++<<8);
		c->blue=(*p++<<8);
		c++;
	}
	XStoreColors(oxlX.disp,oxlX.cmap,oxlX.cols,colorcount);
	XSync(oxlX.disp,False);
}

void oxlX11_blit()
{
	static int frame=0;
	if(!oxlX.opt.useXShm){
#ifdef SUPPORT_REDUCEDSCAN
	if((oxlX.opt.interlaced)||(oxlX.opt.halvescans)){
		int y1=(frame&1)<<oxlX.opt.halvescans,y=0,
		dy1=(1<<(oxlX.opt.interlaced+oxlX.opt.halvescans));
		for(;y<oxl.buf.vh;y++){
		XPutImage(oxlX.disp,oxlX.win,oxlX.gc,oxlX.im,
		0,y,0,y1,oxl.buf.vw,1);
		y1+=dy1;
		}
		frame+=oxlX.opt.interlaced;
	}else
#endif
	XPutImage(oxlX.disp,oxlX.win,oxlX.gc,oxlX.im,
	0,0,0,0,oxl.buf.vw,oxl.buf.vh);
	}
	else
	/* interlasetukset ja muut tllekin */
	XShmPutImage(
		oxlX.disp,oxlX.win,oxlX.gc,oxlX.im,
		0,0,0,0,oxl.buf.vw,oxl.buf.vh,False);
	
	XSync(oxlX.disp,False);
}

int oxlX11_testquit()
{
	XEvent e;
	if((XCheckMaskEvent(oxlX.disp,KeyPressMask|KeyReleaseMask,&e)==True)
	 ||(XEventsQueued(oxlX.disp,QueuedAlready)==True))
	 	return 1;else return 0;
}

/*** WINDOW SETUP FUNX *************************************/

void oxlX11_getcolormap()
{
	int i=0;
	oxlX.cmap=XCreateColormap(oxlX.disp,oxlX.rootw,oxlX.vis,AllocAll);
	for(;i<256;i++){
		oxlX.cols[i].flags=DoRed|DoGreen|DoBlue;
		oxlX.cols[i].pixel=i;oxlX.cols[i].pad=0;
	}
}

void oxlX11_openwindow()
{
	XSetWindowAttributes att;
	Pixmap empty;XColor black={0,0,0,0,0,0};

/* empty cursor */
	empty=XCreatePixmap(oxlX.disp,oxlX.rootw,1,1,1);
	att.cursor=
		XCreatePixmapCursor(oxlX.disp,empty,empty,&black,&black,0,0);

/* fullscreen window */
	if(oxlX.opt.fullscreen){
		att.override_redirect=True;

		if(oxl.buf.vd==8)
		XSetWindowColormap(oxlX.disp,oxlX.rootw,oxlX.cmap);
	}else
		att.override_redirect=False;

/* create window */
	att.backing_store=NotUseful;
	att.colormap=oxlX.cmap;
	oxlX.win=XCreateWindow(
		oxlX.disp,oxlX.rootw,
		0,0,oxl.buf.vw,oxl.buf.vh,0,
		oxl.buf.vd, 
		InputOutput,
		oxlX.vis,
		CWBackingStore|CWCursor|CWOverrideRedirect
		|((oxl.buf.vd==8)?CWColormap:0)
		,&att);

/* some hints&props */
	{XSizeHints shints;
	shints.min_width= shints.max_width= oxl.buf.vw;
	shints.min_height=shints.max_height=oxl.buf.vh;
	shints.flags=PMinSize+PMaxSize;

	XSetStandardProperties(
		oxlX.disp,oxlX.win,
		OXL_XWINNAME,OXL_XWINNAME,
		None,NULL,0,
		&shints);
	}

/* and draw the window */
	XMapWindow(oxlX.disp,oxlX.win);

/* hook keypress */
	XSelectInput(oxlX.disp,oxlX.win,KeyPress|KeyRelease);
	if(oxlX.opt.fullscreen)
	XSelectInput(oxlX.disp,oxlX.rootw,KeyPress|KeyRelease);

/* fullscreen: cursor (and viewport) to upper left corner */
	if(oxlX.opt.fullscreen){
		XWarpPointer(oxlX.disp,
			oxlX.rootw,oxlX.rootw,
			0,0,
			DisplayWidth(oxlX.disp,oxlX.scr),
			DisplayHeight(oxlX.disp,oxlX.scr),
			0,0);
	}

/* blank */

/*	if(oxlX.opt.halvescans) {
		XFillRectangle(oxlX.disp,oxlX.win,
		oxlX.gc,0,0,oxl.buf.vw,oxl.buf.vh);
	} .. not yet*/

/* ok ok */
/*	{XEvent e;
	XMaskEvent(oxlX.disp,KeyPressMask|KeyReleaseMask,&e);}
*/
	XSync(oxlX.disp,False);
}

/*** DISPLAY SETUP FUNX **************************************/

int oxlX11_testdepth(int depth)
{
	Screen*s=ScreenOfDisplay(oxlX.disp,oxlX.scr);
	Depth*d=s->depths;int i=0;
	#ifdef DEBUG
		fprintf(stderr,"testing for depth %i\n",depth);
	#endif
	for(;i<s->ndepths;i++)
		if(d[i].depth==depth)return 1;
	return 0;
}

#ifdef SUPPORT_XF86VM
int oxlX11_getxf86mode()
{
#ifdef SUPPORT_RAWX
	xXF86VidModeGetModeLineReq*req;
	xXF86VidModeGetModeLineReply rep;

	LockDisplay(oxlX.disp);
	_XFlush(oxlX.disp);

	req=(xXF86VidModeGetModeLineReq*)(oxlX.disp->last_req=oxlX.disp->bufptr);
	req->reqType=oxlX.xf86vm_majop;
	req->xf86vidmodeReqType=X_XF86VidModeGetModeLine;
	req->length=(SIZEOF(xXF86VidModeGetModeLineReq))>>2;
	req->screen=oxlX.scr;
	oxlX.disp->bufptr+=SIZEOF(xXF86VidModeGetModeLineReq);
	oxlX.disp->request++;

	if(_XReply(oxlX.disp,(xReply*)&rep,
	(SIZEOF(xXF86VidModeGetModeLineReply)-SIZEOF(xReply))>>2,xFalse)){
	oxlX.savedmode.w=rep.hdisplay;oxlX.savedmode.h=rep.vdisplay;
	if(rep.privsize>0)_XEatData(oxlX.disp,rep.privsize*sizeof(INT32));
	}

	UnlockDisplay(oxlX.disp);
	if(oxlX.disp->synchandler)(*oxlX.disp->synchandler)(oxlX.disp);
#else
	XF86VidModeLine m;int dummy;
	XF86VidModeGetModeLine(oxlX.disp,oxlX.scr,&dummy,&m);
	oxlX.savedmode.w=m.hdisplay;
	oxlX.savedmode.h=m.vdisplay;
#endif
}
#endif

void oxlX11_setvidmode(int*w,int*h)
{
	int w0=*w,h0=*h;int dummy;

	#ifdef SUPPORT_XF86VM
	if(!XQueryExtension(oxlX.disp,XF86VIDMODENAME,&oxlX.xf86vm_majop,&dummy,&dummy))
		oxlX.opt.changemode=0;
	else {
		oxlX11_getxf86mode();
		*w=oxlX.savedmode.w;
		*h=oxlX.savedmode.h;
		return; }

		/* ... get all modes, select the best */

	#endif

	/* no-xf86vm */

	*w=DisplayWidth(oxlX.disp,oxlX.scr);
	*h=DisplayHeight(oxlX.disp,oxlX.scr);
}

#ifdef SUPPORT_XF86DGA
/* ei toimi viel. kai. */
int oxlX11_ready_DGA()
{
	int flags,bank,ram;

	XF86DGAQueryDirectVideo(oxlX.disp,oxlX.scr,&flags);

	fprintf(stderr,"dga flags:%x\n",flags);
	if(!(flags&XF86DGADirectPresent))return 0;
	
	XF86DGADirectVideo(oxlX.disp,oxlX.scr,XF86DGADirectGraphics);
	XF86DGAGetVideo(oxlX.disp,oxlX.scr,&oxl.buf.vdata,&oxl.buf.bpvl,&bank,&ram);
	XF86DGASetViewPort(oxlX.disp,oxlX.scr,0,0);
	if(oxl.buf.vd==8)XF86DGAInstallColormap(oxlX.disp,oxlX.scr,oxlX.cmap);
	oxl.directvideo=1;

	return 1;
}
#endif

#ifdef SUPPORT_MITSHM
int oxlX11_ready_XShm()
{
	oxlX.im=XShmCreateImage(
		oxlX.disp,oxlX.vis,oxl.buf.vd,
		ZPixmap, NULL,&oxlX.ssi,
		oxl.buf.vw,oxl.buf.vh
		);
	if(oxlX.im==NULL)return 0;

	oxl.buf.vh=oxlX.im->height;
	oxl.buf.vw=oxlX.im->width;
	oxl.buf.bpvl=oxlX.im->bytes_per_line;

	oxlX.ssi.shmid=shmget(IPC_PRIVATE,
		oxlX.im->bytes_per_line*oxlX.im->height,
		IPC_CREAT|0777);
	if(oxlX.ssi.shmid<0){
		XDestroyImage(oxlX.im);return 0;}

	oxlX.im->data=oxl.buf.vdata=oxlX.ssi.shmaddr=
	shmat(oxlX.ssi.shmid,0,0);

	if(oxlX.ssi.shmaddr==(void*)-1){
		XDestroyImage(oxlX.im);return 0;}
	
	oxlX.ssi.readOnly=False;
	
	/* XSetErrorHandler. Ei tnne */

	XShmAttach(oxlX.disp,&oxlX.ssi);
	XSync(oxlX.disp,False);

	shmctl(oxlX.ssi.shmid,IPC_RMID,0);
	return 1;
}
#endif

void oxlX11_close()
{
	OXLMSG("closing x11\n");

#ifdef SUPPORT_MITSHM
	if(oxlX.opt.useXShm){
		XShmDetach(oxlX.disp,&oxlX.ssi);
		shmdt(oxlX.ssi.shmaddr);}
#endif
	XDestroyImage(oxlX.im);
	if(oxlX.opt.fullscreen)XDestroyWindow(oxlX.disp,oxlX.dummyw);
	XDestroyWindow(oxlX.disp,oxlX.win);
	if(oxlX.opt.changemode)
		oxlX11_setvidmode(&oxlX.savedmode.w,&oxlX.savedmode.h);
}

void oxlX11_ready()
{
/* color depth */
	if(!oxlX11_testdepth(oxl.buf.vd)){
	if(oxlX11_testdepth(8)) oxl.buf.vd=8;else
	if(oxlX11_testdepth(16))oxl.buf.vd=16;else
	if(oxlX11_testdepth(15))oxl.buf.vd=15;else
	OXLMSG("No suitable depth available (8/15/16 bpp)\n");
	}

	if(oxl.buf.vd==8)oxlX11_getcolormap();

/* dga */
	oxl.directvideo=0;
	#ifdef SUPPORT_XF86DGA
	if(oxlX.opt.useDGA){
		int dummy;
		oxlX.opt.useDGA=XQueryExtension(oxlX.disp,XF86DGANAME,
			&dummy,&dummy,&dummy);
	if(oxlX.opt.useDGA)
		if(oxlX11_ready_DGA())return;
		else{
			oxlX.opt.useDGA=0;
			OXLMSG("no dga\n");}
	}
	#endif

/* xlib fullscreen */
	if(oxlX.opt.fullscreen)
		oxlX11_setvidmode(&oxl.buf.vw,&oxl.buf.vh);

	#ifdef DEBUG
	fprintf(stderr,"openwindow\n");
	#endif

 	oxlX11_openwindow();

	oxl_regdestr(oxlX11_close);

#ifdef SUPPORT_REDUCEDSCAN
	oxl.buf.vh>>=(oxlX.opt.interlaced+oxlX.opt.halvescans);
#endif

/* shared memory buffer */
	#ifdef SUPPORT_MITSHM
	if(oxlX.opt.useXShm){
		oxlX.opt.useXShm=XShmQueryExtension(oxlX.disp);
		/* tarkista mys versiosta pixmaps==true */
	if(oxlX.opt.useXShm)
		if(oxlX11_ready_XShm())return;
		else{
			oxlX.opt.useXShm=0;
			fprintf(stderr,"no xshm\n");}
	}
	#endif

/* noxshm */
	oxl.buf.vdata=malloc(BUFFSIZE(oxl.buf.vw,oxl.buf.vh,oxl.buf.vd));

	oxlX.im=XCreateImage(
		oxlX.disp,oxlX.vis,
		oxl.buf.vd,ZPixmap,           
		0,oxl.buf.vdata,
		oxl.buf.vw,oxl.buf.vh,
		32,BUFFSIZE(1,oxl.buf.vw,oxl.buf.vd));

		oxl.buf.bpvl=oxlX.im->bytes_per_line; /* ? */
}

/*int findarg(int*argc,char**argv,char*key);*/

void oxlX11_init(int*argc,char**argv)
{
	if(oxl.help){
		fprintf(stderr,
			"-d x (X11)\n"
			"  -noxshm\n"
			"  -full (fullscreen, under construction)\n"
#ifdef SUPPORT_REDUCEDSCAN
			"  -il   (interlaced blit)\n"
			"  -hs   (halve scanlines)\n"
#endif
			);
	}
	if(oxl.drv.video_ready!=NULL)return;
	if(!(oxlX.disp=XOpenDisplay(NULL))) return;

	oxl.drv.video_ready=&oxlX11_ready;
	oxl.drv.video_blit=&oxlX11_blit;
	oxl.drv.video_setpalette=&oxlX11_setpalette;
	oxl.drv.testquit=&oxlX11_testquit;

	oxlX.opt.useXShm=!findarg(argc,argv,"-noxshm");
	oxlX.opt.fullscreen=findarg(argc,argv,"-full");
#ifdef SUPPORT_REDUCEDSCAN
	oxlX.opt.interlaced=findarg(argc,argv,"-il")?1:0;
	oxlX.opt.halvescans=findarg(argc,argv,"-hs")?1:0;
#endif
	/*oxlX.opt.changemode=!findarg(argc,argv,"-novm");*/

	oxlX.scr=DefaultScreen(oxlX.disp);
	oxlX.rootw=DefaultRootWindow(oxlX.disp);
	oxlX.gc=DefaultGC(oxlX.disp,oxlX.scr);
	oxlX.vis=DefaultVisual(oxlX.disp,oxlX.scr);
}
#endif
