#include "oxlconfig.h"
#ifdef SUPPORT_AA

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <aalib.h>

#include "oxl.h"

struct{
	aa_context *ctx;
	aa_renderparams *parms;
	aa_palette palette;
}oxlaa;

/**********************/

void oxlaa_close();

void oxlaa_ready()
{
	oxlaa.parms=aa_getrenderparams();
	aa_hidecursor(oxlaa.ctx);

	oxl.buf.vd=8;
	oxl.buf.bpvl=oxl.buf.vw=aa_imgwidth(oxlaa.ctx);
	oxl.buf.vh=aa_imgheight(oxlaa.ctx);
	oxl.buf.vdata=oxlaa.ctx->imagebuffer;

	oxl_regdestr(oxlaa_close);
}

void oxlaa_setpalette(int*pal,int colorcount)
{
	int i=0;
	for(;i<colorcount;i++){
		aa_setpalette(
			oxlaa.palette,i,pal[0],pal[1],pal[2]);
		pal+=3;
	}
}

void oxlaa_blit()
{
	aa_renderpalette(
		oxlaa.ctx,oxlaa.palette,oxlaa.parms,
		0,0,aa_scrwidth(oxlaa.ctx),aa_scrheight(oxlaa.ctx));
	aa_flush(oxlaa.ctx);
}

void oxlaa_close()
{
	aa_showcursor(oxlaa.ctx);
	aa_close(oxlaa.ctx);
}

/*********************/

void oxlaa_init(int*argc,char**argv)
{
	if(oxl.help){puts(aa_help);return;}
	if(oxl.drv.video_ready!=NULL)return;

	aa_parseoptions(NULL,NULL,argc,argv);

	oxlaa.ctx=aa_autoinit(&aa_defparams);
	if(oxlaa.ctx==NULL)return;

	/***/

	oxl.drv.video_ready=&oxlaa_ready;
	oxl.drv.video_blit=&oxlaa_blit;
	oxl.drv.video_setpalette=&oxlaa_setpalette;

	return;
}

#endif