#include "oxlconfig.h"
#ifdef SUPPORT_GGI

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <ggi/ggi.h>

#include "oxl.h"

struct{
	ggi_visual_t vis;
}oxlggi;

/**********************/

void oxlggi_ready()
{
	ggi_mode mode;int gt;

	switch((int)oxl.buf.vd){
#ifdef SUPPORT_8BPP
		case(8):gt=GT_8BIT;break;
#endif
#ifdef SUPPORT_16BPP
		case(16):gt=GT_16BIT;break;
#endif
		default:gt=GGI_AUTO;
	}

	ggiCheckGraphMode(oxlggi.vis,oxl.buf.vw,oxl.buf.vh,
		GGI_AUTO,GGI_AUTO,gt,&mode,NULL);
	ggiSetMode(oxlggi.vis,&mode);
	
	oxl.buf.vw=mode.visible.x;
	oxl.buf.vh=mode.visible.y;
	if(mode.graphtype==GT_8BIT)oxl.buf.vd=8;else
	if(mode.graphtype==GT_15BIT)oxl.buf.vd=15;else
	if(mode.graphtype==GT_16BIT)oxl.buf.vd=16;else
		fprintf(stderr,"what's this graphtype?\n");
}

void oxlggi_setpalette(int*pal,int colorcount)
{
	ggi_color gpal[256];int i;

	for(i=0;i<256;i++){
		gpal[i].r=*pal++<<8;
		gpal[i].g=*pal++<<8;
		gpal[i].b=*pal++<<8;
		gpal[i].a=0;}

	ggiSetPalette(oxlggi.vis,0,256,gpal);
}

void oxlggi_blit()
{
	ggiPutBox(oxlggi.vis,0,0,oxl.buf.vw,oxl.buf.vh,oxl.buf.vdata);
}

int oxlggi_testquit()
{
	return ggiKbhit(oxlggi.vis);
}

void oxlggi_exit()
{
	ggiClose(oxlggi.vis);
	ggiExit();
}

/*********************/

void oxlggi_init(int*argc,char**argv)
{
	if(oxl.help){
		puts("-d g (GGI)\n"
		"  -target [target]\n");return;}
	if(oxl.drv.video_ready!=NULL)return;
	if(ggiInit())return;

	{int i=findarg(argc,argv,"-target");
	if(!(oxlggi.vis=i?ggiOpen(argv[i],NULL):ggiOpen(NULL)))return;
	}

	oxl_regdestr(oxlggi_exit);

	oxl.drv.video_ready=&oxlggi_ready;
	oxl.drv.video_blit=&oxlggi_blit;
	oxl.drv.video_setpalette=&oxlggi_setpalette;

	fprintf(stderr,"ggi ok\n");
}

#endif
