#include "oxlconfig.h"
#ifdef SUPPORT_OSS

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/soundcard.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>

#include "oxl.h"

struct{
	int dev;
	int blksize;
	int usetimer;
	void(*player)();
}oxloss;

/*********/

void oxloss_close()
{
	ioctl(oxloss.dev,SNDCTL_DSP_RESET,0);
	close(oxloss.dev);
}

void oxloss_send(void*buffer,int length)
{
	write(oxloss.dev,buffer,length); /* native format: in bytes */
}

int oxloss_timer()
{
	char started=0;
	count_info ci;int btmr;
	static int lastby=0,desync=0;

	/* desync bug fix */

	for(;;){
		ioctl(oxloss.dev,SNDCTL_DSP_GETOPTR,&ci);
		if((!started)&&(ci.bytes==65536))oxloss.player();
	}
	started=1;

/*	if(lastby<ci.bytes)desync=0; lastby=ci.bytes;
	if(((ci.bytes-desync-ci.ptr)&65535)>0)
		desync+=((ci.bytes-desync-ci.ptr)&65535);*/

	btmr=ci.bytes-desync;

	return (btmr*oxl.timerhz)/(oxl.au.hz*AUBYPS);
}

void oxloss_audio_check()
{
	audio_buf_info a;
	for(;;){
	ioctl(oxloss.dev,SNDCTL_DSP_GETOSPACE,&a);
	if(a.fragments<a.fragstotal/2)break;
	oxloss.player();
	}
}

void oxloss_audio_play(void(*player)())
{
	oxloss.player=player;
	oxl.drv.audio_check=oxloss_audio_check;
	player();

	if(oxloss.usetimer){
		oxl.drv.timer=oxloss_timer;
		oxl_timer(oxl.timerhz);}
}

/*********/

#define NUMFRAGS 32
#define FRAGSIZE 2048
void oxloss_init(int*argc,char**argv)
{
	int tmp=(NUMFRAGS<<16)|FRAGSIZE;oxloss.blksize=FRAGSIZE;
	
	if(oxl.help){OXLMSG("-d o (OSS audio)\n"
	  "  -ossptr (still doesn't want to work with some devices)\n");return;}

	if((oxloss.dev=open("/dev/dsp",O_WRONLY|O_NDELAY,0))<0)return;

	/* SNDCTL_DSP_GETFMS ja SETFMT + stuffo ==> siit mrile mit
	   skaalaajia/klippaajia kytelln

	if(ioctl(oxloss.dev,SNDCTL_DSP_GETFMTS,&tmp)<0)
		OXLMSG("getfmts?\n");else{
		if(tmp&AFMT_U8)oxl.au.scaler=oxl_mixer_scale8u;else
		if(tmp&AFMT_S8)oxl.au.scaler=oxl_mixer_scale8s;else
		if(tmp&AFMT_U16_LE)oxl.au.scaler=oxl_mixer_scale16u;else
		if(tmp&AFMT_S16_LE)oxl.au.scaler=oxl_mixer_scale16s;else
		OXLMSG("no suitable formats?\n");}
	*/

	/* tarkista mys bytecountterin oikea toiminta? */

	if(ioctl(oxloss.dev,SNDCTL_DSP_SETFRAGMENT,&tmp)<0)
		OXLMSG("setfragment?\n");
/*	ifioctl(oxloss.dev,SNDCTL_DSP_SYNC,0)==-1)
		OXLMSG("dspsync?\n");*/

	if(ioctl(oxloss.dev,SNDCTL_DSP_SAMPLESIZE,&oxl.au.bits)<0)
		OXLMSG("samplesize?\n");
	if(ioctl(oxloss.dev,SNDCTL_DSP_STEREO,&oxl.au.chs)<0)
		OXLMSG("dspstereo?\n");
	if(ioctl(oxloss.dev,SNDCTL_DSP_SPEED,&oxl.au.hz)<0)
		OXLMSG("dspspeed?\n");

/*	ioctl(oxloss.dev,SNDCTL_DSP_GETBLKSIZE,&oxloss.blksize); */

	#ifdef DEBUG
	fprintf(stderr,"bits=%i chs=%i hz=%i\n",oxl.au.bits,oxl.au.chs,oxl.au.hz);
	#endif

	oxl.drv.audio_send=oxloss_send;
	oxl.drv.audio_play=oxloss_audio_play;
	oxl.drv.audio_check=oxloss_audio_check;
	oxl_regdestr(oxloss_close);

	oxloss.usetimer=findarg(argc,argv,"-ossptr");

	fprintf(stderr,"OSS driver\n");
}
#endif
