#include "oxlconfig.h"
#ifdef SUPPORT_VGA

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <vga.h>

#include "oxl.h"

/* vga driver specific
struct{
}oxlvga;
*/

/**********************/

void oxlvga_ready()
{
	vga_modeinfo*inf;
	int i=0,best=-1,bestpts=999;
	
 	for(;i<GLASTMODE;i++)
	if(vga_hasmode(i)){
		int depth,pts;
		inf=vga_getmodeinfo(i);
		depth=inf->bytesperpixel<<3;
		if(inf->colors==32768)depth=15;else
		if(inf->colors==256)depth=8;

		if(oxl_evalmode(oxl.buf.w,oxl.buf.h,oxl.buf.d,
			inf->width,inf->height,depth,&bestpts)) best=i;
	}
	if(best>=0){
		vga_setmode(best);
		inf=vga_getmodeinfo(i);
	if((oxl.use_direct)&&(inf->bytesperpixel))
	{
		oxl.buf.bpvl=inf->linewidth;
		oxl.buf.vdata=vga_getgraphmem();
		oxl.directvideo=1;
	}else{
		oxl.buf.bpvl=oxl.buf.vw; /*?*/
		oxl.buf.vdata=malloc(BUFFSIZE(oxl.buf.vw,oxl.buf.vh,oxl.buf.vd));
		oxl.directvideo=0;}
	}
}

void oxlvga_setpalette(int*pal,int colorcount)
{
	int pp[256*3],i=0;
	for(;i<colorcount*3;i++)pp[i]=pal[i]>>2;

	vga_setpalvec(0,colorcount,pp);
}

void oxlvga_blit()
{
	vga_drawscansegment(oxl.buf.vdata,0,0,
		oxl.buf.vw*oxl.buf.vh*(oxl.buf.vd>>3));
}

/*int oxlvga_testquit()*/

void oxlvga_close()
{
	vga_setmode(TEXT);
}

/*********************/

void oxlvga_init(int*argc,char**argv)
{
	if(oxl.help){OXLMSG("-d v  (svgalib)\n");return;}
	if(oxl.drv.video_ready!=NULL)return;

	if((int)getuid())return; /* root? */
	if(vga_init())return;
	
	oxl.drv.video_ready=&oxlvga_ready;
	oxl.drv.video_blit=&oxlvga_blit;
	oxl.drv.video_setpalette=&oxlvga_setpalette;
}

#endif