#include "oxl.h"

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

#ifdef __linux__
#include <linux/string.h>
#else
#include <string.h>
#endif

/***************** scaler **************************/

#ifdef SUPPORT_8TOHIGHER
void oxl_scaler_setpalette(int*pal,int colorcount)
{
	short16*s=oxlscaler.conv8to16;
	int rsh=8,gsh=3,bsh=3,rmask=0xf8,gmask=0xfc;

	if(oxl.buf.vd==15){
		rsh=7;gsh=2;bsh=3;rmask=0xf8;gmask=0xf8;}

	for(;colorcount;colorcount--){
		*s++=
		 ((pal[0]&rmask)<<rsh)
		|((pal[1]&gmask)<<gsh)
		|(pal[2]>>bsh);
		pal+=3;
	}
	/* bigendian conversion? */
}
#endif

void oxl_scaler_do() 
{
	static int phase=0;

	int y=0,vh=oxl.buf.vh;
	char*data=oxl.buf.data,*vdata=oxl.buf.vdata;

	int w=oxl.buf.w,dy=oxlscaler.dy,bpvl=oxl.buf.bpvl;

/*	interlace: phase^=1;if(!phase)vdata+=vw; vh/=2;dy*=2;vw*=2; */
/* vw: pad to full_length, *=bytesperpixel */

	for(;;){
		if(oxlscaler.inloop1==NULL){
			oxlscaler.inloop0(data,vdata,oxl.buf.vw);
		}else{
			oxlscaler.inloop0(data,oxlscaler.temp,oxl.buf.vw);
			oxlscaler.inloop1(oxlscaler.temp,vdata,oxl.buf.vw);
		}
		y+=dy;vdata+=bpvl; /* ? */
		vh--;if(!vh)break; /* ? */
		while(y<256){
			memcpy(vdata,vdata-bpvl,
			BUFFSIZE(1,oxl.buf.vw,oxl.buf.vd)); 
			y+=dy;vdata+=bpvl;
			vh--;if(!vh)return;
		}
		while(y>=256){
			data+=w;y-=256;
		}
	}
}

void oxl_scaler_ready()
{
	static int tempmallocd=0;

#ifdef DEBUG
	fprintf(stderr,"scaler_ready: %i/%i/%i ==> %i/%i/%i\n",
	oxl.buf.w,oxl.buf.h,oxl.buf.d,oxl.buf.vw,oxl.buf.vh,oxl.buf.vd);
#endif

	oxlscaler.dx=(oxl.buf.w<<8)/oxl.buf.vw;
	oxlscaler.dy=(oxl.buf.h<<8)/oxl.buf.vh;

	if(oxl.buf.d==8){

	if(oxl.buf.vd==8)
		oxlscaler.inloop1=NULL;
	#ifdef SUPPORT_8TO16
	else
	if((oxl.buf.vd==15)||(oxl.buf.vd==16))
		oxlscaler.inloop1=oxl_scaler_x8to16_1;
	#endif

	if(oxlscaler.dx==64)
		oxlscaler.inloop0=oxl_scaler_x8_1to4;else
	if(oxlscaler.dx==128)
		oxlscaler.inloop0=oxl_scaler_x8_1to2;else
		oxlscaler.inloop0=oxl_scaler_x8_any;
	}
	
	if((oxlscaler.inloop0==NULL)&&
	(oxlscaler.inloop1!=NULL)){
		oxlscaler.inloop0=oxlscaler.inloop1;
		oxlscaler.inloop1=NULL;
	}
	
	if(oxlscaler.inloop1!=NULL){
		if(tempmallocd)free(oxlscaler.temp);
		oxlscaler.temp=malloc(BUFFSIZE(oxl.buf.vw,1,oxl.buf.vd));
		tempmallocd=1;
	}
}
