#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "oxl_src/oxl.h"

#define XSIZE 320
#define YSIZE 200
#ifndef PI
#define PI 3.1415926
#endif

char tuntxr[256*256];
char tile[256*256];
unsigned short*tuntab;
void tunnelprecalc()
{
	int x,y,r=(oxl_width>oxl_height)?oxl_width:oxl_height;
	unsigned short*t=tuntab=malloc(oxl_width*oxl_height*sizeof(short));

	for(y=0;y<oxl_height;y++){
		float ry=(354*(y-oxl_height/2))/r;
	for(x=0;x<oxl_width;x++){
		float rx=(354*(x-oxl_width/2))/r;
		int rr=sqrt(rx*rx+ry*ry);
		int a=(128/PI)*atan2(ry,rx);
		if(ry<0)a+=256;
		*t++=((rr<<8)|(a&0xff))&0xffff;
	}}
}

#define schar signed char
void maketile()
{
	int x,y;char*t=tile;int joo;
	for(y=256;y;y--){
		int z=64*sin((PI*y)/64);
	for(x=256;x;x--){
		*t++=
			abs((schar)((z+x-100)&255))*4+
			abs((schar)((y-203)&255))*2-
			abs((schar)((z+x-83)&255))*3-
			abs((schar)((z+y-33)&255))*1+
			abs((schar)((z+x-145)&255))*5-
			abs((schar)((y)&255))*4;
	}}
}

void tt(int y0,int x0,int t0)
{
	char*t=tuntxr;int y=256-8,stepo=1024<<10;
	memset(t,0,256*8);t+=256*8;
	x0&=255;y0<<=18;
	for(;y;y--){
	char*tt=tile+(((y0>>18)&0xff)<<8);
	if(x0)memcpy(t+256-x0,tt,x0);
	memcpy(t,tt+x0,256-x0);
	t+=256;
	y0+=stepo;stepo-=(stepo>>5)-(stepo>>6);}
}

void dotunnel(char*d,unsigned short*t)
{
	int i=oxl_width*oxl_height;
	for(;i;i--)*d++=tuntxr[*t++];
}

void drawfx(char*d,int t)
{
	tt(~t,t,40);
	dotunnel(d,tuntab);
}

char*buf;

void setpal(float cz)
{
	int pal[256*3],i=256,*p=pal;
	for(;i;i--){
		float amp=(.5+(sin(i/(PI*8))))*(256-i)/512;
		int r,g,b;
		r=amp*(128+125*cos(14.5+cz+i/80));
		g=amp*(128-127*cos(7+cz*1.4+i/48));
		b=amp*(128+126*sin(.8+cz*.86+i/66));
		if(r>255)r=255;
		if(g>255)g=255;
		if(b>255)b=255;
		*p++=r;*p++=g;*p++=b;
	}
	oxl_setpalette(pal,256);
}

void main(int argc,char**argv)
{

	oxl_init(&argc,argv);
	oxl_video(XSIZE,YSIZE,8);
	buf=oxl_video(oxl_width,oxl_height,8);
	setpal(7777);
	fprintf(stderr,"precalcs\n");
	tunnelprecalc();
	maketile();
	fprintf(stderr,"action!\n");

	oxl_timer(100);
	while(!oxl_testquit())
	{
		int t=oxl_timer(0);
		drawfx(buf,t);
		setpal(((float)t)/100);
		oxl_blit(NULL);
	}
	oxl_close();
}
